2011-01-11 06:46:27 +08:00
#!/usr/bin/env zsh
# -------------------------------------------------------------------------------------------------
2017-12-25 16:41:53 +08:00
# Copyright (c) 2010-2017 zsh-syntax-highlighting contributors
2011-01-11 06:46:27 +08:00
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without modification, are permitted
# provided that the following conditions are met:
#
# * Redistributions of source code must retain the above copyright notice, this list of conditions
# and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright notice, this list of
# conditions and the following disclaimer in the documentation and/or other materials provided
# with the distribution.
# * Neither the name of the zsh-syntax-highlighting contributors nor the names of its contributors
# may be used to endorse or promote products derived from this software without specific prior
# written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
# FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
# IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# -------------------------------------------------------------------------------------------------
# -*- mode: zsh; sh-indentation: 2; indent-tabs-mode: nil; sh-basic-offset: 2; -*-
# vim: ft=zsh sw=2 ts=2 et
# -------------------------------------------------------------------------------------------------
2017-11-05 00:19:00 +08:00
setopt NO_UNSET WARN_CREATE_GLOBAL
2017-11-03 08:25:23 +08:00
2019-01-07 11:19:46 +08:00
local -r root = ${ 0 : h : h }
2019-01-12 14:35:18 +08:00
local -a anon_argv; anon_argv = ( " $@ " )
2019-01-07 11:19:46 +08:00
2019-01-12 14:35:18 +08:00
( ) {
set -- " ${ (@)anon_argv } "
2011-06-13 04:57:14 +08:00
# Check an highlighter was given as argument.
[ [ -n " $1 " ] ] || {
2015-10-23 13:34:01 +08:00
echo >& 2 "Bail out! You must provide the name of a valid highlighter as argument."
exit 2
2011-06-13 04:57:14 +08:00
}
# Check the highlighter is valid.
2019-01-07 11:19:46 +08:00
[ [ -f $root /highlighters/$1 /$1 -highlighter.zsh ] ] || {
2016-01-21 06:01:45 +08:00
echo >& 2 " Bail out! Could not find highlighter ${ (qq)1 } . "
2015-10-23 13:34:01 +08:00
exit 2
2011-06-13 04:57:14 +08:00
}
# Check the highlighter has test data.
2019-01-07 11:19:46 +08:00
[ [ -d $root /highlighters/$1 /test-data ] ] || {
2016-01-21 06:01:45 +08:00
echo >& 2 " Bail out! Highlighter ${ (qq)1 } has no test data. "
2015-10-23 13:34:01 +08:00
exit 2
2011-06-13 04:57:14 +08:00
}
2016-12-02 17:50:55 +08:00
# Set up results_filter
local results_filter
2017-11-03 08:24:56 +08:00
if [ [ ${ QUIET - } = = y ] ] ; then
2016-12-02 17:50:55 +08:00
if type -w perl >/dev/null; then
2019-01-07 11:19:46 +08:00
results_filter = $root /tests/tap-filter
2016-12-02 17:50:55 +08:00
else
echo >& 2 "Bail out! quiet mode not supported: perl not found" ; exit 2
fi
else
results_filter = cat
fi
[ [ -n $results_filter ] ] || { echo >& 2 "Bail out! BUG setting \$results_filter" ; exit 2 }
2011-01-11 06:46:27 +08:00
# Load the main script.
2016-12-02 17:35:29 +08:00
# While here, test that it doesn't eat aliases.
2019-01-07 11:19:46 +08:00
print > >( $results_filter | $root /tests/tap-colorizer.zsh) -r -- "# global (driver) tests"
print > >( $results_filter | $root /tests/tap-colorizer.zsh) -r -- "1..1"
2016-12-02 17:35:29 +08:00
alias -- +plus= plus
alias -- _other = other
2019-01-07 11:18:41 +08:00
local original_alias_dash_L_output = " $( alias -L) "
2019-01-07 11:19:46 +08:00
. $root /zsh-syntax-highlighting.zsh
2016-12-02 17:35:29 +08:00
if [ [ $original_alias_dash_L_output = = $( alias -L) ] ] ; then
print -r -- "ok 1 # 'alias -- +foo=bar' is preserved"
else
print -r -- "not ok 1 # 'alias -- +foo=bar' is preserved"
exit 1
2019-01-07 11:19:46 +08:00
fi > >( $results_filter | $root /tests/tap-colorizer.zsh)
2011-06-13 04:57:14 +08:00
2016-04-03 09:27:10 +08:00
# Overwrite _zsh_highlight_add_highlight so we get the key itself instead of the style
_zsh_highlight_add_highlight( )
{
region_highlight += ( " $1 $2 $3 " )
}
2011-06-13 04:57:14 +08:00
# Activate the highlighter.
ZSH_HIGHLIGHT_HIGHLIGHTERS = ( $1 )
2011-01-11 06:46:27 +08:00
2018-12-29 19:57:15 +08:00
# In zsh<5.3, 'typeset -p arrayvar' emits two lines, so we use this wrapper instead.
typeset_p( ) {
2020-02-22 22:29:55 +08:00
for 1 ; do
if [ [ ${ (tP)1 } = = *array* ] ] ; then
2020-03-20 03:15:21 +08:00
print -r -- " $1 =( ${ (@qqqqP)1 } ) "
2020-02-22 22:29:55 +08:00
else
2020-03-20 03:15:21 +08:00
print -r -- " $1 = ${ (qqqqP)1 } "
2020-02-22 22:29:55 +08:00
fi
done
2018-12-29 19:57:15 +08:00
}
2018-12-29 20:15:34 +08:00
# Escape # as ♯ and newline as ↵ they are illegal in the 'description' part of TAP output
# The string to escape is «"$@"»; the result is returned in $REPLY.
tap_escape( ) {
2020-03-18 00:22:56 +08:00
local s = " ${ (j. .)@ } "
2018-12-29 20:15:34 +08:00
REPLY = " ${ ${ s // '#' /♯ } // $'\n' /↵ } "
}
2015-10-23 11:27:05 +08:00
# Runs a highlighting test
# $1: data file
2015-11-17 06:54:52 +08:00
run_test_internal( ) {
2011-01-11 06:46:27 +08:00
2015-11-17 06:54:52 +08:00
local tests_tempdir = " $1 " ; shift
local srcdir = " $PWD "
2018-01-12 22:28:08 +08:00
builtin cd -q -- " $tests_tempdir " || { echo >& 2 " Bail out! On ${ (qq)1 } : cd failed: $? " ; return 1 }
2015-11-17 06:54:52 +08:00
2011-01-11 06:46:27 +08:00
# Load the data and prepare checking it.
2020-03-19 08:37:21 +08:00
local BUFFER CURSOR MARK PENDING PREBUFFER REGION_ACTIVE WIDGET REPLY skip_test fail_test unsorted = 0
2018-12-29 19:31:18 +08:00
local expected_mismatch
2020-03-17 22:58:00 +08:00
local skip_mismatch
2017-11-05 00:18:31 +08:00
local -a expected_region_highlight region_highlight
2020-02-22 22:33:39 +08:00
2020-03-18 00:35:14 +08:00
local ARG = " $1 "
2020-03-19 07:55:10 +08:00
local RETURN = ""
2020-03-18 00:35:14 +08:00
( ) {
setopt localoptions
2011-01-11 06:46:27 +08:00
2020-03-18 00:35:14 +08:00
# WARNING: The remainder of this anonymous function will run with the test's options in effect
2020-03-19 08:37:21 +08:00
if { ! . " $srcdir " /" $ARG " } || ( ( $# fail_test ) ) ; then
print -r -- "1..1"
print -r -- " ## ${ ARG : t : r } "
tap_escape $fail_test ; fail_test = $REPLY
print -r -- " not ok 1 - failed setup: $fail_test "
return ${ RETURN : =0 }
fi
2017-11-06 21:08:53 +08:00
2020-03-19 08:16:09 +08:00
( ( $# skip_test ) ) && {
print -r -- " 1..0 # SKIP $skip_test "
print -r -- " ## ${ ARG : t : r } "
return ${ RETURN : =0 }
}
2015-10-23 11:27:05 +08:00
2020-03-18 00:35:14 +08:00
# Check the data declares $PREBUFFER or $BUFFER.
2020-06-11 16:09:45 +08:00
[ [ -z $PREBUFFER && -z $BUFFER ] ] && { echo >& 2 " Bail out! On ${ (qq)ARG } : Either 'PREBUFFER' or 'BUFFER' must be declared and non-blank " ; return ${ RETURN : =1 } ; }
2017-11-03 08:09:32 +08:00
2020-03-18 00:35:14 +08:00
# Set sane defaults for ZLE variables
: ${ CURSOR = $# BUFFER } ${ PENDING =0 } ${ WIDGET =z-sy-h-test-harness-test-widget }
# Process the data.
_zsh_highlight
2020-03-19 07:55:10 +08:00
} ; [ [ -z $RETURN ] ] || return $RETURN
2020-03-18 00:35:14 +08:00
unset ARG
2015-10-23 11:27:05 +08:00
2020-05-22 11:27:48 +08:00
integer print_expected_and_actual = 0
2018-02-07 09:14:26 +08:00
if ( ( unsorted ) ) ; then
region_highlight = ( " ${ (@n)region_highlight } " )
expected_region_highlight = ( " ${ (@n)expected_region_highlight } " )
fi
2015-10-23 11:27:05 +08:00
2020-02-22 22:37:14 +08:00
# Print the plan line, and some comments for human readers
2018-02-07 09:14:26 +08:00
echo " 1.. $(( $# expected_region_highlight + 1 )) "
2020-03-15 21:33:09 +08:00
echo " ## ${ 1 : t : r } " # note: tests/edit-failed-tests looks for the "##" emitted by this line
2020-02-22 22:37:14 +08:00
[ [ -n $PREBUFFER ] ] && printf '# %s\n' " $( typeset_p PREBUFFER) "
[ [ -n $BUFFER ] ] && printf '# %s\n' " $( typeset_p BUFFER) "
2018-02-07 09:14:26 +08:00
local i
for ( ( i = 1; i<= $# expected_region_highlight; i++) ) ; do
local -a expected_highlight_zone; expected_highlight_zone = ( ${ (z)expected_region_highlight[i] } )
integer exp_start = $expected_highlight_zone [ 1] exp_end = $expected_highlight_zone [ 2]
2015-10-23 12:26:51 +08:00
local todo =
tests: Skip cardinality tests whenever any test point is expected to fail.
When writing an expected-to-fail test case, the cardinality of $region_highlight
at the time the test is written may differ from the cardinality it will have
once the bug is fixed. For example, with issue #641.5, the current highlighting
is ['nice', 'x=y', 'y', 'ls'] — four elements — but the correct highlighting
would have three elements: ['nice', 'x=y', 'ls']. There is no point in reporting
a separate test failure for the cardinality check in this case, nor for 'ls' being
highlighted as 'command' rather than 'default'.
At the same time, in other cases the current and correct highlighting may have the
same number of elements (for example, this would be the case for a hypothetical
"the command word is highlighted as an alias rather than a function" bug). Thus,
the previous commit, q.v..
2019-11-10 19:35:21 +08:00
if ( ( $+expected_highlight_zone[ 4] ) ) ; then
todo = " # TODO $expected_highlight_zone [4] "
2020-03-17 22:58:00 +08:00
skip_mismatch = "cardinality check disabled whilst regular test points are expected to fail"
tests: Skip cardinality tests whenever any test point is expected to fail.
When writing an expected-to-fail test case, the cardinality of $region_highlight
at the time the test is written may differ from the cardinality it will have
once the bug is fixed. For example, with issue #641.5, the current highlighting
is ['nice', 'x=y', 'y', 'ls'] — four elements — but the correct highlighting
would have three elements: ['nice', 'x=y', 'ls']. There is no point in reporting
a separate test failure for the cardinality check in this case, nor for 'ls' being
highlighted as 'command' rather than 'default'.
At the same time, in other cases the current and correct highlighting may have the
same number of elements (for example, this would be the case for a hypothetical
"the command word is highlighted as an alias rather than a function" bug). Thus,
the previous commit, q.v..
2019-11-10 19:35:21 +08:00
fi
2018-02-07 09:14:26 +08:00
if ! ( ( $+region_highlight[ i] ) ) ; then
2020-02-29 06:31:36 +08:00
print -r -- " not ok $i - unmatched expectation ( $exp_start $exp_end $expected_highlight_zone [3]) " \
2020-03-17 22:58:00 +08:00
" ${ skip_mismatch : + " # TODO ${ (qqq)skip_mismatch } " } "
2020-05-22 11:27:48 +08:00
if [ [ -z $skip_mismatch ] ] ; then ( ( ++print_expected_and_actual ) ) ; fi
2018-02-07 09:14:26 +08:00
continue
fi
local -a highlight_zone; highlight_zone = ( ${ (z)region_highlight[i] } )
integer start = $(( highlight_zone[ 1 ] + 1 )) end = $highlight_zone [ 2]
2018-12-29 20:15:34 +08:00
local desc = " [ $start , $end ] « ${ BUFFER [ $start , $end ] } » "
tap_escape $desc ; desc = $REPLY
2018-02-07 09:14:26 +08:00
if
[ [ $start != $exp_start ] ] ||
[ [ $end != $exp_end ] ] ||
[ [ $highlight_zone [ 3] != $expected_highlight_zone [ 3] ] ]
then
print -r -- " not ok $i - $desc - expected ( $exp_start $exp_end ${ (qqq)expected_highlight_zone[3] } ), observed ( $start $end ${ (qqq)highlight_zone[3] } ). $todo "
2020-05-22 11:27:48 +08:00
if [ [ -z $todo ] ] ; then ( ( ++print_expected_and_actual ) ) ; fi
2018-02-07 09:14:26 +08:00
else
print -r -- " ok $i - $desc ${ todo : + - } $todo "
fi
unset expected_highlight_zone
unset exp_start exp_end
2016-05-06 02:44:54 +08:00
unset todo
unset highlight_zone
2018-02-07 09:14:26 +08:00
unset start end
unset desc
2015-10-23 11:27:05 +08:00
done
2018-02-07 09:14:26 +08:00
2020-03-17 22:58:00 +08:00
# If both $skip_mismatch and $expected_mismatch are set, that means the test
# has some XFail test points, _and_ explicitly sets $expected_mismatch as
# well. Explicit settings should have priority, so we ignore $skip_mismatch
# if $expected_mismatch is set.
if [ [ -n $skip_mismatch && -z $expected_mismatch ] ] ; then
tap_escape $skip_mismatch ; skip_mismatch = $REPLY
print " ok $i - cardinality check " " # SKIP $skip_mismatch "
2018-02-07 09:14:26 +08:00
else
2020-03-17 22:58:00 +08:00
local todo
if [ [ -n $expected_mismatch ] ] ; then
tap_escape $expected_mismatch ; expected_mismatch = $REPLY
todo = " # TODO $expected_mismatch "
fi
2020-03-17 22:53:09 +08:00
if ( ( $# expected_region_highlight = = $# region_highlight ) ) ; then
2020-03-17 22:58:00 +08:00
print -r -- " ok $i - cardinality check ${ todo : + - } $todo "
2020-03-17 22:53:09 +08:00
else
local details
details += " have $# expected_region_highlight expectations and $# region_highlight region_highlight entries: "
details += " « $( typeset_p expected_region_highlight) » « $( typeset_p region_highlight) » "
tap_escape $details ; details = $REPLY
2020-03-17 22:58:00 +08:00
print -r -- " not ok $i - cardinality check - $details ${ todo : + - } $todo "
2020-05-22 11:27:48 +08:00
if [ [ -z $todo ] ] ; then ( ( ++print_expected_and_actual ) ) ; fi
fi
fi
if ( ( print_expected_and_actual ) ) ; then
2020-03-19 13:00:22 +08:00
( ) {
local -a left_column right_column
left_column = ( "expected_region_highlight" " ${ (qq)expected_region_highlight[@] } " )
right_column = ( "region_highlight" " ${ (qq)region_highlight[@] } " )
integer difference = $(( $# right_column - $# left_column ))
2020-03-20 06:45:37 +08:00
repeat $difference do left_column += ( .) ; done
2020-03-20 06:39:30 +08:00
paste \
= ( print -rC1 -- $left_column ) \
= ( print -rC1 -- $right_column ) \
| if type column >/dev/null; then column -t -s $'\t' ; else cat; fi \
2020-03-19 13:00:22 +08:00
| sed 's/^/# /'
}
2018-02-07 09:14:26 +08:00
fi
2015-10-23 11:27:05 +08:00
}
2011-01-11 06:46:27 +08:00
2016-01-02 00:35:00 +08:00
# Run a single test file. The exit status is 1 if the test harness had
# an error and 0 otherwise. The exit status does not depend on whether
# test points succeeded or failed.
2015-11-17 06:54:52 +08:00
run_test( ) {
# Do not combine the declaration and initialization: «local x="$(false)"» does not set $?.
2015-11-17 09:05:05 +08:00
local __tests_tempdir
__tests_tempdir = " $( mktemp -d) " && [ [ -d $__tests_tempdir ] ] || {
2015-11-17 06:54:52 +08:00
echo >& 2 "Bail out! mktemp failed" ; return 1
2015-11-17 09:05:05 +08:00
}
2015-11-17 06:54:52 +08:00
typeset -r __tests_tempdir # don't allow tests to override the variable that we will 'rm -rf' later on
{
2016-01-02 00:35:00 +08:00
# Use a subshell to isolate tests from each other.
# (So tests can alter global shell state using 'cd', 'hash', etc)
2016-05-13 10:39:11 +08:00
{
# These braces are so multios don't come into play.
{ ( run_test_internal " $__tests_tempdir " " $@ " ) 3>& 1 >& 2 2>& 3 } | grep \^
local ret = $pipestatus [ 1] stderr = $pipestatus [ 2]
if ( ( ! stderr ) ) ; then
# stdout will become stderr
2020-02-22 22:31:18 +08:00
echo " Bail out! On ${ (qq)1 } : output on stderr " ; return 1
2016-05-13 10:39:11 +08:00
else
return $ret
fi
} 3>& 1 >& 2 2>& 3
2015-11-17 06:54:52 +08:00
} always {
rm -rf -- " $__tests_tempdir "
}
}
2015-10-23 11:27:05 +08:00
# Process each test data file in test data directory.
integer something_failed = 0
2016-04-25 12:22:14 +08:00
ZSH_HIGHLIGHT_STYLES = ( )
2019-01-07 11:18:41 +08:00
local data_file
2019-01-07 11:19:46 +08:00
for data_file in $root /highlighters/$1 /test-data/*.zsh; do
run_test " $data_file " | tee >( $results_filter | $root /tests/tap-colorizer.zsh) | grep -v '^not ok.*# TODO' | grep -Eq '^not ok|^ok.*# TODO' && ( ( something_failed = 1 ) )
2015-10-23 11:27:05 +08:00
( ( $pipestatus [ 1] ) ) && exit 2
2011-01-11 06:46:27 +08:00
done
2015-09-05 17:27:51 +08:00
exit $something_failed
2019-01-12 14:35:18 +08:00
}